#ifndef BODY_KUBO_DRIBBLE_H
#define BODY_KUBO_DRIBBLE_H

#include <rcsc/player/soccer_action.h>
#include <rcsc/geom/vector_2d.h>

#include <vector>

//enum{KIWAMU,ONE,KUBO};

//typeKIWAMU,ONE,KUBOΤɤ줫
//طʤϲƤɤ
class Body_KuboDribble
    : public rcsc::BodyAction {
private:
    const double M_dist; //for kubo
    const int M_afraid;  //for kubo
    bool kuboDribble(rcsc::PlayerAgent * agent);
    bool searchSafetyDir(rcsc::PlayerAgent * agent,
                         const std::vector< rcsc::Vector2D > & kubopoint,
                         int &direction,
                         const int kuboafraid);
        
public:

    Body_KuboDribble( const double & dist,
                      const int & afraid)
    :M_dist(dist),
     M_afraid(afraid)
    { }

    bool execute( rcsc::PlayerAgent * agent );

};

#endif
