#ifndef RL_METHOD_H
#define RL_METHOD_H

#include "action.h"
#include "state.h"

class RLMethod
{ 
private:

public:

    RLMethod(){ }

    virtual ~RLMethod(){ }

    virtual
    void init(){ }

    virtual
    Action selectAction( const State & s ) = 0;

    virtual
    bool update( const State & s, Action a, const double & r ) = 0;

    //ü֤Ǥ󽷻Ȥäƹ
    //ü֤ʤΤs,aϹ˴ؤʤ
    virtual
    bool update( const double & r) = 0;

    //ʹؿɤ߹
    virtual
    bool readValue( const std::string & file_name ) = 0;

    //ʹؿ򲿤餫η¸
    virtual
    bool writeValue( const std::string & file_name ) = 0;

protected:

    //chooseActionǺǸAction
    Action M_last_selected_action;

    //Ǹ˹줿
    State M_last_state;

};

#endif
