#ifndef OFFENSESYSTEM_H
#define OFFENSESYSTEM_H

#include <rcsc/player/player_agent.h>
#include <rcsc/common/logger.h>
#include <rcsc/geom/vector_2d.h>

enum{TEAM,OPP};

class OffenseSystem
{
public:
    
    OffenseSystem(){};
    
    //playertarget_pointãޤǤΥ֤
    //ԤΤȤ1000֤
    static int getPointReachCycle(rcsc::PlayerAgent * agent,
                                  const rcsc::Vector2D & target_point,
                                  const rcsc::AbstractPlayerObject & player);

    //kickMultiStepΥܡȤ륹ƥå׿׻
    //true,Ԥʤfalse
//     static bool simulateKickMultiStep(rcsc::PlayerAgent * agent,
//                                       const rcsc::Vector2D & target_point,
//                                       const double & first_speed,
//                                       rcsc::Vector2D & ball_result_pos,
//                                       rcsc::Vector2D & ball_result_vel,
//                                       int & kick_step);

    //target_point˺®ãcount_thrŨȤõ
    //륵ֹǤ
    //ޤʤfalse֤
    //skip_goalie
    static bool pointPredict(rcsc::PlayerAgent * agent,
                             const rcsc::Vector2D & target_point,
                             const int & count_thr,
                             const int & mode,
                             int * fastest_cycle,
                             int * fastest_unum,
                             bool skip_goalie=false);

    //ʬμȾrǺǤŨΥݥƥ󥷥뤬㤤֤
    static rcsc::Vector2D  getMinCongestionPoint(rcsc::PlayerAgent * agent,
                                                 const double & r);


    //饤ǤΥݥƥ󥷥ζ˾ͤõ
    //target_point˰ֶᤤ˾֤ͤ
    static double getLineCongestion(rcsc::PlayerAgent * agent,
                                  const double & lineX,
                                  const rcsc::Vector2D & target_point);

    
private:
    //target_pointŨݥƥ󥷥׻
    static double  calcCongestion(rcsc::PlayerAgent * agent,
                                  const rcsc::Vector2D & target_point);


    

};

#endif
